GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
TPG::TPGExecutionEngineInstrumented Class Reference

`#include <tpgExecutionEngineInstrumented.h>`

Inheritance diagram for TPG::TPGExecutionEngineInstrumented:

## Public Member Functions
| TPGExecutionEngineInstrumented (const Environment &env, Archive *arch=NULL)
| Main constructor of the class.
double | evaluateEdge (const TPGEdge &edge) override
| Specialization of the evaluateEdge function.
const TPG::TPGEdge & | evaluateTeam (const TPGTeam &team) override
| Specialization of the evaluateTeam function.
const std::pair< std::vector< const TPG::TPGVertex * >, std::vector< double > > | executeFromRoot (const TPG::TPGVertex &root, const std::vector< uint64_t > &initActions={ 0}) override
| Specialization of the evaluateTeam function.
const std::vector< std::vector< const TPGVertex * > > & | getTraceHistory () const
| Get all previous execution traces.
void | clearTraceHistory ()
| Clear the trace history from all previous execution trace.
Public Member Functions inherited from TPG::TPGExecutionEngine
| TPGExecutionEngine (const Environment &env, Archive *arch=NULL)
| Main constructor of the class.
virtual | ~TPGExecutionEngine ()=default
| Default virtual destructor.
void | setArchive (Archive *newArchive)
| Set a new Archive for storing Program results.
void | applyActivationFunctionOnActions (std::vector< double > &actionsTaken)
| Apply a sigmoid function on all the actions.

## Protected Attributes
std::vector< std::vector< const TPGVertex * > > | traceHistory
Protected Attributes inherited from TPG::TPGExecutionEngine
Archive * | archive
| Archive for recording Program results.
const Environment & | env
| Environment used.
Program::ProgramExecutionEngine | progExecutionEngine
| ProgramExecutionEngine for executing Programs of edges.

## Detailed Description

Specialization of the TPGExecutionEngine class.

## Constructor & Destructor Documentation

## ◆ TPGExecutionEngineInstrumented()

TPG::TPGExecutionEngineInstrumented::TPGExecutionEngineInstrumented | ( | const Environment & | env,
|  | Archive * | arch = NULL )
| inline

Main constructor of the class.

Parameters

  [in] | env | Environment in which the Program of the TPGGraph will be executed.
  [in] | arch | pointer to the Archive for storing recordings of the Program Execution. By default, a NULL pointer is given, meaning that no recording of the execution will be made.

## Member Function Documentation

## ◆ evaluateEdge()

double TPG::TPGExecutionEngineInstrumented::evaluateEdge | ( | const TPGEdge & | edge | ) |
| override virtual

Specialization of the evaluateEdge function.

In addition to calling the evaluateEdge method from TPGExecutionEngine, this specialization increments the number of visits of the evaluated TPGEdge.

Copyright or © or Copr. IETR/INSA - Rennes (2022 - 2025) :

Elinor Montmasson elino.nosp@m.r.mo.nosp@m.ntmas.nosp@m.son@.nosp@m.gmail.nosp@m..com (2022) Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2022) Quentin Vacher qvach.nosp@m.er@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2025)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

Reimplemented from TPG::TPGExecutionEngine.

## ◆ evaluateTeam()

const TPG::TPGEdge & TPG::TPGExecutionEngineInstrumented::evaluateTeam | ( | const TPGTeam & | team | ) |
| override virtual

Specialization of the evaluateTeam function.

In addition to calling the evaluateTeam method from TPGExecutionEngine, this specialization increments the number of visits of the evaluated TPGTeam and the number of traversal of the TPGEdge with the winning bid.

Reimplemented from TPG::TPGExecutionEngine.

## ◆ executeFromRoot()

const std::pair< std::vector< const TPG::TPGVertex * >, std::vector< double > > TPG::TPGExecutionEngineInstrumented::executeFromRoot | ( | const TPG::TPGVertex & | root,
|  | const std::vector< uint64_t > & | initActions = { 0} )
| override virtual

Specialization of the evaluateTeam function.

In addition to calling the executeFromRoot method from TPGExecutionEngine, this specialization increments the number of visits of the reached TPGAction.

Reimplemented from TPG::TPGExecutionEngine.

## Member Data Documentation

## ◆ traceHistory

std::vector<std::vector<const TPGVertex*> > TPG::TPGExecutionEngineInstrumented::traceHistory
| protected

History of all previous execution traces. New traces are pushed back.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/tpg/instrumented/tpgExecutionEngineInstrumented.h
- D:/a/gegelati/gegelati/gegelatilib/src/tpg/instrumented/tpgExecutionEngineInstrumented.cpp